
if (CMAKE_VERSION VERSION_LESS 2.8.3)
    message(FATAL_ERROR "Qt 5 requires at least CMake version 2.8.3")
endif()

get_filename_component(_qt5Mof_install_prefix "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

set(Qt5Mof_VERSION_MAJOR 5)
set(Qt5Mof_VERSION_MINOR 0)
set(Qt5Mof_VERSION_PATCH 0)
set(Qt5Mof_VERSION_STRING 5.0.0)

set(Qt5Mof_LIBRARIES Qt5::Mof)

set(Qt5Mof_INCLUDE_DIRS "${_qt5Mof_install_prefix}/include/qt5/" "${_qt5Mof_install_prefix}/include/qt5/QtMof")
set(Qt5Mof_PRIVATE_INCLUDE_DIRS
    "${_qt5Mof_install_prefix}/include/qt5/QtMof/${Qt5Mof_VERSION_STRING}"
    "${_qt5Mof_install_prefix}/include/qt5/QtMof/${Qt5Mof_VERSION_STRING}/QtMof"
)

set(Qt5Mof_DEFINITIONS -DQT_MOF_LIB)
set(Qt5Mof_COMPILE_DEFINITIONS QT_MOF_LIB)

set(_Qt5Mof_MODULE_DEPENDENCIES "WrappedObjects;Core")

set(_Qt5Mof_FIND_DEPENDENCIES_REQUIRED)
if (Qt5Mof_FIND_REQUIRED)
    set(_Qt5Mof_FIND_DEPENDENCIES_REQUIRED REQUIRED)
endif()
set(_Qt5Mof_FIND_DEPENDENCIES_QUIET)
if (Qt5Mof_FIND_QUIETLY)
    set(_Qt5Mof_DEPENDENCIES_FIND_QUIET QUIET)
endif()

foreach(_module_dep ${_Qt5Mof_MODULE_DEPENDENCIES})
    if (NOT Qt5${_module_dep}_FOUND)
        find_package(Qt5${_module_dep}
            ${_Qt5Mof_DEPENDENCIES_FIND_QUIET}
            ${_Qt5Mof_FIND_DEPENDENCIES_REQUIRED}
            PATHS "${_qt5Mof_install_prefix}" NO_DEFAULT_PATH
        )
    endif()

    if (NOT Qt5${_module_dep}_FOUND)
        set(Qt5Mof_FOUND False)
        return()
    endif()

    list(APPEND Qt5Mof_INCLUDE_DIRS "${Qt5${_module_dep}_INCLUDE_DIRS}")
    list(APPEND Qt5Mof_PRIVATE_INCLUDE_DIRS "${Qt5${_module_dep}_PRIVATE_INCLUDE_DIRS}")
    list(APPEND Qt5Mof_DEFINITIONS ${Qt5${_module_dep}_DEFINITIONS})
    list(APPEND Qt5Mof_COMPILE_DEFINITIONS ${Qt5${_module_dep}_COMPILE_DEFINITIONS})
    list(APPEND Qt5Mof_EXECUTABLE_COMPILE_FLAGS ${Qt5${_module_dep}_EXECUTABLE_COMPILE_FLAGS})
endforeach()
list(REMOVE_DUPLICATES Qt5Mof_INCLUDE_DIRS)
list(REMOVE_DUPLICATES Qt5Mof_PRIVATE_INCLUDE_DIRS)
list(REMOVE_DUPLICATES Qt5Mof_DEFINITIONS)
list(REMOVE_DUPLICATES Qt5Mof_COMPILE_DEFINITIONS)
if (Qt5Mof_EXECUTABLE_COMPILE_FLAGS)
  list(REMOVE_DUPLICATES Qt5Mof_EXECUTABLE_COMPILE_FLAGS)
endif()

set(_Qt5Mof_LIB_DEPENDENCIES "Qt5::WrappedObjects;Qt5::Core")

macro(_populate_imported_target_properties Configuration LIB_LOCATION IMPLIB_LOCATION)
    set_property(TARGET Qt5::Mof APPEND PROPERTY IMPORTED_CONFIGURATIONS ${Configuration})

    set_target_properties(Qt5::Mof PROPERTIES
        "IMPORTED_LINK_INTERFACE_LIBRARIES_${Configuration}" "${_Qt5Mof_LIB_DEPENDENCIES}"
        "IMPORTED_LOCATION_${Configuration}" "${_qt5Mof_install_prefix}/lib/${LIB_LOCATION}"
        "IMPORTED_SONAME_${Configuration}" "libQt5Mof.so.5"
    )
endmacro()

if (NOT TARGET Qt5::Mof)
    add_library(Qt5::Mof SHARED IMPORTED)


    _populate_imported_target_properties(RELEASE "libQt5Mof.so.5.0.0" "" )



endif()


